#ifndef CLICK_GTVS_HH
#define CLICK_GTVS_HH

#include <click/element.hh>
#include <clicknet/tcp.h>

#include "flowcache.hh"
#include "dataexport.hh"

CLICK_DECLS

class GTVS: public Element, FlowCache::FlowStateHolder
{
public:

    GTVS() {}
    ~GTVS() {}

    const char* class_name() const { return "GTVS"; }

    int configure(Vector<String>& conf, ErrorHandler* errh);

    void write_header(DataExport& exporter) const;
    void write_flow_state(DataExport& exporter, const BaseFlowState*) const;

    bool ignore_null_state() const { return true; }
};

CLICK_ENDDECLS

#endif

